#include <conio.h>
#include <iostream.h>
#include <stdlib.h>

#include "combsort.h"
#include "bubsort.h"
#include "exchsort.h"
#include "bsearch.h"
#include "vector.h"

int	compare( int t1, int t2 )
{
	if( t1 < t2 )
		return -1;	// t1 < t2
	if( t1 > t2 )
		return 1;	// t1 > t2

	return 0;		// t1 == t2
}

void	test( Vector< int >& vec )
{

	for( long i = 0; i < vec.sizeOf(); i++ ) {
	     vec[i] = rand();
	     if( !(vec.rdstate() & VectorError::error) )
		cout << vec.peekAt( i ) << endl;
	}

//	bubblesort( vec, vec.sizeOf(), compare );
//	exchangesort( vec, vec.sizeOf(), compare );
	combsort( vec, vec.currentSize(), compare );

	cout << "Item found at index "
	     << bsearch( vec, 7117, vec.sizeOf(), compare )
	     << endl;

	for( long j = 0; j < vec.sizeOf(); j++ )
		cout << vec[j] << endl;

}


void	main( int argc, char *argv[] )
{
clrscr();
Vector< int > vec( atol( argv[1] ) );

	if( !vec || vec.isEmpty() ) {
		cout << "Failure within Vector class" << endl;
		delete[] buffer;
		return;
	}

	test( vec );
}